Index: /palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_u.f90	(revision 1339)
+++ /palm/trunk/SOURCE/diffusion_u.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -131,14 +131,14 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmyp = 0.25 *                                                  &
+                kmyp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-                kmym = 0.25 *                                                  &
+                kmym = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + 2.0 * (                                              &
+                      & + 2.0_wp * (                                           &
                       &           km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   )    &
                       &         - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) )    &
-                      &         ) * ddx2                                       &
+                      &            ) * ddx2                                    &
                       & + ( kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy         &
                       &   + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx         &
@@ -150,17 +150,17 @@
 !
 !--          Wall functions at the north and south walls, respectively
-             IF ( wall_u(j,i) /= 0.0 )  THEN
+             IF ( wall_u(j,i) /= 0.0_wp )  THEN
 
                 DO  k = nzb_u_inner(j,i)+1, nzb_u_outer(j,i)
-                   kmyp = 0.25 *                                               &
+                   kmyp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-                   kmym = 0.25 *                                               &
+                   kmym = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
 
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                                        km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i) ) &
                                      - km(k,j,i-1) * ( u(k,j,i) - u(k,j,i-1) ) &
-                                         ) * ddx2                              &
+                                            ) * ddx2                           &
                                  + (   fyp(j,i) * (                            &
                                   kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy   &
@@ -182,7 +182,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
@@ -211,7 +211,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                       ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                       ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
@@ -231,7 +231,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
@@ -303,14 +303,14 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmyp = 0.25 *                                               &
+                   kmyp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-                   kmym = 0.25 *                                               &
+                   kmym = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
 
                    tend(k,j,i) = tend(k,j,i)                                   &
-                         & + 2.0 * (                                           &
+                         & + 2.0_wp * (                                        &
                          &           km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   ) &
                          &         - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) ) &
-                         &         ) * ddx2                                    &
+                         &            ) * ddx2                                 &
                          & + ( kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy      &
                          &   + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx      &
@@ -325,16 +325,16 @@
              DO  k = 1, nzt
                 IF( k > nzb_u_inner(j,i)  .AND.  k <= nzb_u_outer(j,i)  .AND.  &
-                    wall_u(j,i) /= 0.0 )  THEN
-
-                   kmyp = 0.25 *                                               &
+                    wall_u(j,i) /= 0.0_wp )  THEN
+
+                   kmyp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-                   kmym = 0.25 *                                               &
+                   kmym = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
 
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                                        km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i) ) &
                                      - km(k,j,i-1) * ( u(k,j,i) - u(k,j,i-1) ) &
-                                         ) * ddx2                              &
+                                            ) * ddx2                           &
                                  + (   fyp(j,i) * (                            &
                                   kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy   &
@@ -357,7 +357,7 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmzp = 0.25 *                                               &
+                   kmzp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-                   kmzm = 0.25 *                                               &
+                   kmzm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
@@ -394,7 +394,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                       ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                       ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
@@ -422,7 +422,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
@@ -478,12 +478,12 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmyp = 0.25 * ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-          kmym = 0.25 * ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
+          kmyp = 0.25_wp * ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
+          kmym = 0.25_wp * ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & + 2.0 * (                                              &
+                      & + 2.0_wp * (                                           &
                       &           km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   )    &
                       &         - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) )    &
-                      &         ) * ddx2                                       &
+                      &            ) * ddx2                                    &
                       & + ( kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy         &
                       &   + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx         &
@@ -495,5 +495,5 @@
 !
 !--    Wall functions at the north and south walls, respectively
-       IF ( wall_u(j,i) .NE. 0.0 )  THEN
+       IF ( wall_u(j,i) .NE. 0.0_wp )  THEN
 
 !
@@ -503,12 +503,12 @@
 
           DO  k = nzb_u_inner(j,i)+1, nzb_u_outer(j,i)
-             kmyp = 0.25 * ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-             kmym = 0.25 * ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
+             kmyp = 0.25_wp * ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
+             kmym = 0.25_wp * ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
 
              tend(k,j,i) = tend(k,j,i)                                         &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                                        km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i) ) &
                                      - km(k,j,i-1) * ( u(k,j,i) - u(k,j,i-1) ) &
-                                         ) * ddx2                              &
+                                            ) * ddx2                           &
                                  + (   fyp(j,i) * (                            &
                                   kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy   &
@@ -530,6 +530,6 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-          kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
+          kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
+          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
@@ -557,6 +557,6 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-          kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
+          kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
+          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
@@ -575,7 +575,7 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25 *                                                        &
+          kmzp = 0.25_wp *                                                     &
                  ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-          kmzm = 0.25 *                                                        &
+          kmzm = 0.25_wp *                                                     &
                  ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
Index: /palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_v.f90	(revision 1339)
+++ /palm/trunk/SOURCE/diffusion_v.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -129,7 +129,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmxp = 0.25 * &
+                kmxp = 0.25_wp * &
                        ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                kmxm = 0.25 * &
+                kmxm = 0.25_wp * &
                        ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
@@ -140,25 +140,25 @@
                       &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
                       &   ) * ddx                                              &
-                      & + 2.0 * (                                              &
+                      & + 2.0_wp * (                                           &
                       &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )      &
                       &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )      &
-                      &         ) * ddy2
+                      &            ) * ddy2
              ENDDO
 
 !
 !--          Wall functions at the left and right walls, respectively
-             IF ( wall_v(j,i) /= 0.0 )  THEN
+             IF ( wall_v(j,i) /= 0.0_wp )  THEN
 
                 DO  k = nzb_v_inner(j,i)+1, nzb_v_outer(j,i)
-                   kmxp = 0.25 *                                               &
+                   kmxp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                   kmxm = 0.25 *                                               &
+                   kmxm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
                    
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                                        km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) ) &
                                      - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) ) &
-                                         ) * ddy2                              &
+                                            ) * ddy2                           &
                                  + (   fxp(j,i) * (                            &
                                   kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx   &
@@ -180,7 +180,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 * &
+                kmzp = 0.25_wp * &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 * &
+                kmzm = 0.25_wp * &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -209,7 +209,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -229,7 +229,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -301,7 +301,7 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmxp = 0.25 *                                               &
+                   kmxp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                   kmxm = 0.25 *                                               &
+                   kmxm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
@@ -312,8 +312,8 @@
                          &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy          &
                          &   ) * ddx                                           &
-                         & + 2.0 * (                                           &
+                         & + 2.0_wp * (                                        &
                          &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )   &
                          &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )   &
-                         &         ) * ddy2
+                         &            ) * ddy2
                 ENDIF
              ENDDO
@@ -323,16 +323,16 @@
              DO  k = 1, nzt
                 IF( k > nzb_v_inner(j,i)  .AND.  k <= nzb_v_outer(j,i)  .AND.  &
-                    wall_v(j,i) /= 0.0 )  THEN
-
-                   kmxp = 0.25 *                                               &
+                    wall_v(j,i) /= 0.0_wp )  THEN
+
+                   kmxp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                   kmxm = 0.25 *                                               &
+                   kmxm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
                    
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                                        km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) ) &
                                      - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) ) &
-                                         ) * ddy2                              &
+                                            ) * ddy2                           &
                                  + (   fxp(j,i) * (                            &
                                   kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx   &
@@ -355,7 +355,7 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmzp = 0.25 *                                               &
+                   kmzp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                   kmzm = 0.25 *                                               &
+                   kmzm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -392,7 +392,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -420,7 +420,7 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 *                                                  &
+                kmzp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 *                                                  &
+                kmzm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -476,6 +476,6 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmxp = 0.25 * ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-          kmxm = 0.25 * ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+          kmxp = 0.25_wp * ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+          kmxm = 0.25_wp * ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
@@ -485,13 +485,13 @@
                       &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
                       &   ) * ddx                                              &
-                      & + 2.0 * (                                              &
+                      & + 2.0_wp * (                                           &
                       &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )      &
                       &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )      &
-                      &         ) * ddy2
+                      &            ) * ddy2
        ENDDO
 
 !
 !--    Wall functions at the left and right walls, respectively
-       IF ( wall_v(j,i) /= 0.0 )  THEN
+       IF ( wall_v(j,i) /= 0.0_wp )  THEN
 
 !
@@ -501,14 +501,14 @@
 
           DO  k = nzb_v_inner(j,i)+1, nzb_v_outer(j,i)
-             kmxp = 0.25 *                                                     &
+             kmxp = 0.25_wp *                                                  &
                     ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-             kmxm = 0.25 *                                                     &
+             kmxm = 0.25_wp *                                                  &
                     ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
              tend(k,j,i) = tend(k,j,i)                                         &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                                        km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) ) &
                                      - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) ) &
-                                         ) * ddy2                              &
+                                            ) * ddy2                           &
                                  + (   fxp(j,i) * (                            &
                                   kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx   &
@@ -530,6 +530,6 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-          kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+          kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
@@ -557,6 +557,6 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-          kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+          kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
@@ -575,7 +575,7 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25 * &
+          kmzp = 0.25_wp * &
                  ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-          kmzm = 0.25 * &
+          kmzm = 0.25_wp * &
                  ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
Index: /palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_w.f90	(revision 1339)
+++ /palm/trunk/SOURCE/diffusion_w.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -158,10 +158,10 @@
                       &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)  &
                       & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)  &
-                      &         ) * ddzu(k+1)
+                      &            ) * ddzu(k+1)
              ENDDO
 
 !
 !--          Wall functions at all vertical walls, where necessary
-             IF ( wall_w_x(j,i) /= 0.0  .OR.  wall_w_y(j,i) /= 0.0 )  THEN
+             IF ( wall_w_x(j,i) /= 0.0_wp  .OR.  wall_w_y(j,i) /= 0.0_wp )  THEN
 
                 DO  k = nzb_w_inner(j,i)+1, nzb_w_outer(j,i)
@@ -198,8 +198,8 @@
                                      + wall_w_y(j,i) * wsvs(k,j,i)             &
                                    ) * ddy                                     &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                            km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
                          - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                                         ) * ddzu(k+1)
+                                            ) * ddzu(k+1)
                 ENDDO
              ENDIF
@@ -288,5 +288,5 @@
                          &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
                          & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                         &         ) * ddzu(k+1)
+                         &            ) * ddzu(k+1)
                 ENDIF
              ENDDO
@@ -297,5 +297,5 @@
 
                 IF ( k > nzb_w_inner(j,i)  .AND.  k <= nzb_w_outer(j,i)  .AND. &
-                     wall_w_x(j,i) /= 0.0  .AND.  wall_w_y(j,i) /= 0.0 )  THEN
+                     wall_w_x(j,i) /= 0.0_wp  .AND.  wall_w_y(j,i) /= 0.0_wp )  THEN
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
@@ -330,8 +330,8 @@
                                      + wall_w_y(j,i) * wsvs(k,j,i)             &
                                    ) * ddy                                     &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                            km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
                          - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                                         ) * ddzu(k+1)
+                                            ) * ddzu(k+1)
                 ENDIF
              ENDDO
@@ -400,25 +400,25 @@
                       &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)  &
                       & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)  &
-                      &         ) * ddzu(k+1)
+                      &            ) * ddzu(k+1)
        ENDDO
 
 !
 !--    Wall functions at all vertical walls, where necessary
-       IF ( wall_w_x(j,i) /= 0.0  .OR.  wall_w_y(j,i) /= 0.0 )  THEN
+       IF ( wall_w_x(j,i) /= 0.0_wp  .OR.  wall_w_y(j,i) /= 0.0_wp )  THEN
 
 !
 !--       Calculate the horizontal momentum fluxes w'u' and/or w'v'
-          IF ( wall_w_x(j,i) /= 0.0 )  THEN
+          IF ( wall_w_x(j,i) /= 0.0_wp )  THEN
              CALL wall_fluxes( i, j, nzb_w_inner(j,i)+1, nzb_w_outer(j,i),     &
                                wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp )
           ELSE
-             wsus = 0.0
+             wsus = 0.0_wp
           ENDIF
 
-          IF ( wall_w_y(j,i) /= 0.0 )  THEN
+          IF ( wall_w_y(j,i) /= 0.0_wp )  THEN
              CALL wall_fluxes( i, j, nzb_w_inner(j,i)+1, nzb_w_outer(j,i),     &
                                wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp )
           ELSE
-             wsvs = 0.0
+             wsvs = 0.0_wp
           ENDIF
 
@@ -452,8 +452,8 @@
                                      + wall_w_y(j,i) * wsvs(k)                 &
                                    ) * ddy                                     &
-                                 + 2.0 * (                                     &
+                                 + 2.0_wp * (                                  &
                            km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
                          - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                                         ) * ddzu(k+1)
+                                            ) * ddzu(k+1)
           ENDDO
        ENDIF
